@echo off
setlocal EnableDelayedExpansion

rem ----- Check whether the script runs with admin rights -----
net session >nul 2>&1
if errorlevel 1 goto error_message

rem ----- Delete program files -----
rmdir /s /q "%ProgramFiles%\IDEMIA"
rmdir /s /q "%ProgramFiles(x86)%\IDEMIA"
rmdir /s /q "%ProgramFiles%\Minidriver"
rmdir /s /q "%ProgramFiles%\Open-EID"
rmdir /s /q "%ProgramFiles(x86)%\Open-EID"
rmdir /s /q "%ProgramFiles%\TeRa Client"
del /f "%windir%\System32\esteidcm*.dll"
del /f "%windir%\SysWOW64\esteidcm*.dll"
del /f "%windir%\System32\EstIDMinidriver*.dll"
del /f "%windir%\SysWOW64\EstIDMinidriver.dll"
del /f "%windir%\System32\onepin-opensc-pkcs11.dll"
del /f "%windir%\SysWOW64\onepin-opensc-pkcs11.dll"
del /f "%windir%\System32\scardspen.dll"
del /f "%windir%\SysWOW64\scardspen.dll"
del /f "%windir%\System32\OcsPKCS11Wrapper.dll"
del /f "%windir%\SysWOW64\OcsPKCS11Wrapper.dll"

rem ----- Delete start menu and desktop icons -----
del /f "%public%\desktop\DigiDoc3 klient.lnk"
del /f "%public%\desktop\DigiDoc3 client.lnk"
del /f "%public%\desktop\DigiDoc3 krpto.lnk"
del /f "%public%\desktop\DigiDoc3 crypto.lnk"
del /f "%public%\desktop\DigiDoc4 klient.lnk"
del /f "%public%\desktop\DigiDoc4 client.lnk"
del /f "%public%\desktop\ID-kaardi haldusvahend.lnk"
del /f "%public%\desktop\ID-card utility.lnk"
del /f "%public%\desktop\TeRa Client.lnk"
rmdir /s /q "%ALLUSERSPROFILE%\Microsoft\Windows\Start Menu\Programs\ID-kaart"
rmdir /s /q "%ALLUSERSPROFILE%\Microsoft\Windows\Start Menu\Programs\ID-card"

rem ----- Remove Idemia directories from PATH -----
set $line=%PATH%
set $line=%$line: =#%
set $line=%$line:;= %
set $line=%$line:)=]%
for %%a in (%$line%) do echo %%a | findstr "\IDEMIA" >nul || set $newpath=!$newpath!;%%a
set $newpath=!$newpath:#= !
set $newpath=!$newpath:]=)!
echo New PATH = !$newpath:~1!
setx /m PATH !$newpath:~1!

rem ----- Open-EID-17.12.0.1770 -----
rmdir /s /q "%ProgramData%\Package Cache\{3b50e9fc-73c5-490e-8383-517403365f1a}"
rmdir /s /q "%ProgramData%\Package Cache\{7793934f-2381-4910-94f8-bb70d10b16d5}"

rem ----- Open-EID 18.6.0.1791 -----
rmdir /s /q "%programdata%\package cache\{76d1e827-0f37-47e6-85e2-50c407bb7e05}"
rmdir /s /q "%programdata%\package cache\{fbab8f49-cd0c-43f9-82df-db2b6dd1aa70}"

rem ----- Open-EID 18.10.0.1806 -----
rmdir /s /q "%programdata%\package cache\{76158836-a8b1-4142-820b-4b411e2b35c9}"
rmdir /s /q "%programdata%\package cache\{e36afa6a-ad0e-4461-8e27-b6eea6c46482}"

rem ----- Open-EID 18.10.0.1807 -----
rmdir /s /q "%programdata%\package cache\{c15f5fb6-7998-4af0-8462-36064a3243cc}"
rmdir /s /q "%programdata%\package cache\{4cfe17f8-268c-4851-a3bf-d859bbf7064f}"

rem ----- Open-EID 18.12.0.1819 -----
rmdir /s /q "%programdata%\package cache\{51965622-cb68-46ef-8363-15b639df6f2d}"
rmdir /s /q "%programdata%\package cache\{13703598-3e95-429f-84ab-6214847919f0}"
rmdir /s /q "%programdata%\package cache\{8C15E6D5-4FCE-4774-BF1D-EB41F8CC9B75}v3.12.2.158"
rmdir /s /q "%programdata%\package cache\{AA65CF3A-B655-409B-8596-7E6DE2167CCF}v3.12.2.158"
rmdir /s /q "%programdata%\package cache\{C66CD92C-959A-4E2F-A325-AC5F38FA24B4}v5.3.0.176"
rmdir /s /q "%programdata%\package cache\{88DE7757-604C-4358-AD9F-6E58BA5D7044}v5.3.0.176"
rmdir /s /q "%programdata%\package cache\{72555BBB-6AAA-4975-9B74-EDC6377CA370}v5.3.0.176"
rmdir /s /q "%programdata%\package cache\{3AB96C49-2939-4AEB-BA49-99F10B917DB0}v5.3.0.176"
rmdir /s /q "%programdata%\package cache\{688DEAF4-2B0B-4F19-81AB-D51348C36730}v3.13.0.993"
rmdir /s /q "%programdata%\package cache\{BF4EDF90-6F91-43EE-9C69-DE3B438A5F06}v3.13.0.993"
rmdir /s /q "%programdata%\package cache\{CB4C7ECB-ED2D-41C7-9FF6-D5D5A70FF131}v1.0.8.500"
rmdir /s /q "%programdata%\package cache\{57C5141E-FB18-4A50-9D54-4A789995CF9C}v1.0.8.500"
rmdir /s /q "%programdata%\package cache\{1F6F11B0-D656-47DB-A0A8-05D1B634D521}v3.12.5.1019"
rmdir /s /q "%programdata%\package cache\{6F63BD9C-1F85-4EC8-A74A-CC814BE37501}v3.12.5.1019"
rmdir /s /q "%programdata%\package cache\{EFF2AE99-2192-4369-8A39-A5F8EECFE816}v3.13.1.1075"
rmdir /s /q "%programdata%\package cache\{54D5F856-12F2-4F54-82CB-B550502D9BEA}v3.13.1.1075"
rmdir /s /q "%programdata%\package cache\{552B10D8-9CFF-4806-95BD-F9894883A510}v4.2.0.42"
rmdir /s /q "%programdata%\package cache\{95256391-BCBA-4C0F-A926-55082DBAA1ED}v4.2.0.42"
rmdir /s /q "%programdata%\package cache\{24ABE707-CD89-487A-A0D2-EFA5C8590852}v4.2.0.42"
rmdir /s /q "%programdata%\package cache\{D951705A-3891-43B9-A8F3-8B482FA0A861}v4.2.0.42"
rmdir /s /q "%programdata%\package cache\{BF1AD4B2-658A-4551-8D34-B0E0D8B138C8}v3.13.6.2"
rmdir /s /q "%programdata%\package cache\{5D5A621E-A43F-4A96-A288-D06B50776FDA}v3.13.6.2"
rmdir /s /q "%programdata%\package cache\{18FC32F6-E531-4F53-9639-652B78B75762}v1.1.0.13"
rmdir /s /q "%programdata%\package cache\{B93C4D41-880A-4AAB-97DE-1C0949CC663D}v1.1.0.13"
rmdir /s /q "%programdata%\package cache\{080C10B7-6FE7-475E-A840-2FABDBD08AF0}v18.12.0.1819"

rem ----- Open-EID 19.3.0.1828 -----
rmdir /s /q "%programdata%\package cache\{f997a7fa-a420-43ba-bb8e-4b95220d068d}"
rmdir /s /q "%programdata%\package cache\{77d409b1-95ea-4853-9106-cebe7635898a}"
rmdir /s /q "%programdata%\package cache\{E6198680-8C51-4274-8E14-0283E11C9DCC}v4.2.1.49"
rmdir /s /q "%programdata%\package cache\{33DBB70F-CC12-427C-9274-F0C9184A6E38}v4.2.1.49"
rmdir /s /q "%programdata%\package cache\{FA5693EE-6111-482C-8470-F00DE9259B22}v4.2.1.49"
rmdir /s /q "%programdata%\package cache\{D1F5D0A6-D3AF-4962-9ECB-CF3D929CFE3B}v4.2.1.49"
rmdir /s /q "%programdata%\package cache\{38556DED-904D-41C7-B4EC-3D723F4AD4CF}v19.3.0.1828"

rem ----- Open-EID 19.7.0.1837 -----
rmdir /s /q "%programdata%\package cache\{c5c49395-55f1-41d6-83f0-88fa6e2c15a8}"
rmdir /s /q "%programdata%\package cache\{280a5f91-96f5-4038-b322-704c63013f01}"
rmdir /s /q "%programdata%\package cache\{CD591B98-0FD2-49D9-974B-29B337084CC2}v5.3.1.294"
rmdir /s /q "%programdata%\package cache\{F3545094-3ABC-4116-88BE-8A8FF0B95E47}v5.3.1.294"
rmdir /s /q "%programdata%\package cache\{811CEA74-3814-408F-B09B-F9C7FF271725}v5.3.1.294"
rmdir /s /q "%programdata%\package cache\{9D62B42E-2C5A-4C5C-86F7-5AFDE892165B}v5.3.1.294"
rmdir /s /q "%programdata%\package cache\{1A3965F7-F1F9-404C-84C1-8086079FF606}v1.0.9.507"
rmdir /s /q "%programdata%\package cache\{B1491267-3F6F-480B-90AA-F39291D0F19F}v1.0.9.507"
rmdir /s /q "%programdata%\package cache\{A98D0443-02DE-48D2-B30F-40133A246503}v3.12.6.1021"
rmdir /s /q "%programdata%\package cache\{F242F02E-AA4D-4155-A7D3-1C81895A7857}v3.12.6.1021"
rmdir /s /q "%programdata%\package cache\{9DD11576-668D-44FA-B711-E6BA770ABD5B}v3.13.3.1077"
rmdir /s /q "%programdata%\package cache\{8806A9DA-DBF5-4A36-89F3-FC371C8E85B4}v3.13.3.1077"
rmdir /s /q "%programdata%\package cache\{3272F899-2173-427F-964F-54447199BB6D}v4.2.2.51"
rmdir /s /q "%programdata%\package cache\{8D16FEF7-0DAF-4984-BC24-D8ACD408BD14}v4.2.2.51"
rmdir /s /q "%programdata%\package cache\{14E1D368-1C26-4B54-A568-3EEC2E565078}v4.2.2.51"
rmdir /s /q "%programdata%\package cache\{65FE125F-2AB6-4427-A634-839D1EBF839F}v4.2.2.51"
rmdir /s /q "%programdata%\package cache\{0975FCD5-3ECA-458D-ACC2-70B07F0BA5E2}v3.13.6.3"
rmdir /s /q "%programdata%\package cache\{8EBF197C-BDF6-4C12-A6C2-06FEA61AC1A5}v3.13.6.3"
rmdir /s /q "%programdata%\package cache\{268D5AEF-A68F-4AD2-90A0-7EDBB978F43B}v19.7.0.1837"

rem ----- Open-EID 19.8.0.1844 -----
rmdir /s /q "%programdata%\package cache\{d0f399bc-c86f-43bf-a922-2d8782819886}"
rmdir /s /q "%programdata%\package cache\{6c61fefc-2318-4f5f-82c2-9ff9d89fb8df}"
rmdir /s /q "%programdata%\package cache\{FBB4228D-D1BF-4E88-ACD4-8E5D00566AF0}v4.2.2.57"
rmdir /s /q "%programdata%\package cache\{435A9695-C1FD-4359-84B4-3FCE2C0430AC}v4.2.2.57"
rmdir /s /q "%programdata%\package cache\{CD491FFB-F34A-4760-860C-D00A12559F89}v4.2.2.57"
rmdir /s /q "%programdata%\package cache\{D2D23738-7339-4D85-8169-AC6C2DCB5D30}v4.2.2.57"
rmdir /s /q "%programdata%\package cache\{6DE5A923-75EC-4A7C-B892-66876DE4F274}v19.8.0.1844"

rem ----- Open-EID 19.10.0.1852 -----
rmdir /s /q "%programdata%\package cache\{b87d1072-2e72-494b-bcab-abaf0a2614f0}"
rmdir /s /q "%programdata%\package cache\{950a7538-9ae1-47f5-8505-d11d7707e985}"
rmdir /s /q "%programdata%\package cache\{299E6366-6AAC-4CCE-BE39-218BC44C0C31}v5.3.2.328"
rmdir /s /q "%programdata%\package cache\{6269E560-0FDF-4DD5-B63A-6390B6D6B762}v5.3.2.328"
rmdir /s /q "%programdata%\package cache\{00B1E4F6-17E7-430B-AC68-78F2583763C8}v5.3.2.328"
rmdir /s /q "%programdata%\package cache\{D2C69823-998E-4090-92D2-12042BA3BBB8}v5.3.2.328"
rmdir /s /q "%programdata%\package cache\{80A2074F-0231-4879-B149-38D91BB2D61B}v1.1.0.512"
rmdir /s /q "%programdata%\package cache\{900FAFBA-0CFC-47D0-977F-9C2C9D218936}v1.1.0.512"
rmdir /s /q "%programdata%\package cache\{6D90E5BC-64BE-4B84-BDB2-6E436FB16A93}v3.12.7.1025"
rmdir /s /q "%programdata%\package cache\{1A3B6241-268D-48EC-9893-99579990EE70}v3.12.7.1025"
rmdir /s /q "%programdata%\package cache\{245182CB-933D-4C87-8AAE-B2563B07A10C}v4.2.3.66"
rmdir /s /q "%programdata%\package cache\{ADEE2C37-BB98-4ABC-8DA1-B5A33AEDE881}v4.2.3.66"
rmdir /s /q "%programdata%\package cache\{506995C8-7209-406B-9267-72A5EB0780D2}v4.2.3.66"
rmdir /s /q "%programdata%\package cache\4B02EF394D6254244B5E47BE7B8C3B97v4.2.3.66"
rmdir /s /q "%programdata%\package cache\{E4374D50-49A4-4E89-AD10-F5039A49F4C6}v3.13.7.4"
rmdir /s /q "%programdata%\package cache\{86C90D7E-C104-43BD-93E0-DE30A4982F95}v3.13.7.4"
rmdir /s /q "%programdata%\package cache\{5B3D8AB0-F660-4C4D-829D-E4448CA07861}v1.2.0.253"
rmdir /s /q "%programdata%\package cache\{7C59D14D-C92B-4DAF-9FDD-43258D3222CC}v1.2.0.253"
rmdir /s /q "%programdata%\package cache\{865066F3-875A-45AC-ABED-FB4CB7846878}v19.10.0.1852"

rem ----- Open-EID 20.01.0.1861 -----
rmdir /s /q "%programdata%\package cache\{8a65d30f-4a74-4255-b5b2-aedd7797a7ea}"
rmdir /s /q "%programdata%\package cache\{56efb102-c6f9-4ad1-9782-01085610234d}"
rmdir /s /q "%programdata%\package cache\{CC15A913-C014-48D4-B466-F0CE76C459C7}v5.3.3.350"
rmdir /s /q "%programdata%\package cache\{72AADA09-C90B-4C2D-8211-1BFBF7CEB2F5}v5.3.3.350"
rmdir /s /q "%programdata%\package cache\{3883C327-19F6-4301-8660-BD4B17FB63CB}v5.3.3.350"
rmdir /s /q "%programdata%\package cache\{EF40F98D-03D7-44DA-B1BC-4CBCE84EA6D4}v5.3.3.350"
rmdir /s /q "%programdata%\package cache\{3E4537F2-F5DA-41EB-9A58-71F9ADA18843}v3.13.3.997"
rmdir /s /q "%programdata%\package cache\{5D68C565-0022-418F-9B92-8DE0CA6A7DA4}v3.13.3.997"
rmdir /s /q "%programdata%\package cache\{0E7FE006-D4C7-42CB-87EA-9EAD67B9010F}v1.1.1.513"
rmdir /s /q "%programdata%\package cache\{65544023-3B29-4A11-B294-54F9DA7E3807}v1.1.1.513"
rmdir /s /q "%programdata%\package cache\{13C70EA2-0BDE-4D39-81A6-4B5A45CB249A}v3.12.8.1028"
rmdir /s /q "%programdata%\package cache\{516AC913-0456-4B5D-A9BD-6ADE145E1487}v3.12.8.1028"
rmdir /s /q "%programdata%\package cache\{FA754165-35D2-4013-84D4-D89FC79A346D}v3.13.4.1080"
rmdir /s /q "%programdata%\package cache\{B5B48C8B-CDD8-43FC-8B22-E24A278C65FD}v3.13.4.1080"
rmdir /s /q "%programdata%\package cache\{EDDB96A3-E1A3-4D36-AF04-D5A5FED1DB38}v4.2.4.71"
rmdir /s /q "%programdata%\package cache\{3F1B1B0C-3709-46B2-A0ED-EBA5E4B4B162}v4.2.4.71"
rmdir /s /q "%programdata%\package cache\{9D2BC5B1-6FCE-457D-8E9D-13E48253049B}v4.2.4.71"
rmdir /s /q "%programdata%\package cache\{66924B17-0772-425A-8569-8D5CAEA8C16A}v4.2.4.71"
rmdir /s /q "%programdata%\package cache\{2A0BA700-F5F0-4D55-81CD-AD120093FF50}v20.01.0.1861"

rem ----- Open-EID 20.05.0.1867 -----
rmdir /s /q "%programdata%\package cache\{95d27cc6-a3f9-4246-9ba6-edd348a9aedc}"
rmdir /s /q "%programdata%\package cache\{a9c764c9-9367-4e91-baad-af48e888fa8f}"
rmdir /s /q "%programdata%\package cache\{4D4EA8EC-8250-4D1D-94DE-088B6688ACDB}v5.3.4.363"
rmdir /s /q "%programdata%\package cache\{FB41DD7B-4BB8-4862-B2D7-FF8E7A673FE6}v5.3.4.363"
rmdir /s /q "%programdata%\package cache\{82B38741-DD3F-4CFE-A379-DC9D3B5979D8}v5.3.4.363"
rmdir /s /q "%programdata%\package cache\{63901F73-DDC9-473E-9F4F-45ABC25B4B7A}v5.3.4.363"
rmdir /s /q "%programdata%\package cache\{232E0D71-0C13-4235-99E6-7BE2FF69EEF5}v3.13.4.998"
rmdir /s /q "%programdata%\package cache\{82E0A93C-3F04-4734-A7DE-7593B6EF1FE9}v3.13.4.998"
rmdir /s /q "%programdata%\package cache\{BA753000-10C2-4734-A747-5361A57194DC}v1.1.2.520"
rmdir /s /q "%programdata%\package cache\{B70A88FA-06A2-459A-BD99-D71846A9F13D}v1.1.2.520"
rmdir /s /q "%programdata%\package cache\{86CCCB64-78A2-4C17-BF7B-36C10745C472}v3.12.9.1030"
rmdir /s /q "%programdata%\package cache\{6F464A68-0A51-4441-993E-FF8640743A52}v3.12.9.1030"
rmdir /s /q "%programdata%\package cache\{7D7E248A-897E-457A-853C-54ADA35C375C}v3.13.6.1084"
rmdir /s /q "%programdata%\package cache\{3DEAE0F1-6911-4183-A6DE-DEB1A15CA6D4}v3.13.6.1084"
rmdir /s /q "%programdata%\package cache\{E00409E2-FE37-4F8B-A25D-D63A52CB9F69}v4.2.5.76"
rmdir /s /q "%programdata%\package cache\{C0F59C8C-4D10-431A-9FF6-345D587A38AA}v4.2.5.76"
rmdir /s /q "%programdata%\package cache\{FFB42627-A786-471F-9CD1-4B189C72EAE4}v4.2.5.76"
rmdir /s /q "%programdata%\package cache\{2BBF45F0-DC40-4842-82EF-1F06BC4675C3}v4.2.5.76"
rmdir /s /q "%programdata%\package cache\{5DDDE145-B76A-40F3-ABEA-4F173A9006C8}v20.05.0.1867"

rem ----- Open-EID 20.09.0.1881 -----
rmdir /s /q "%programdata%\package cache\{05527924-1a7a-409a-ae6c-5c80a10728cc}"
rmdir /s /q "%programdata%\package cache\{fd5a87af-d666-4079-8fed-38cfb8a27723}"
rmdir /s /q "%programdata%\package cache\{22211195-0C2B-4610-B597-8289CA128727}v3.13.0.1040"
rmdir /s /q "%programdata%\package cache\{8B110B04-BC4A-428D-A9C9-CFD213CF8700}v3.13.0.1040"
rmdir /s /q "%programdata%\package cache\{FECCA4FB-367E-45FC-83AF-D6975B4ECE86}v3.13.6.1085"
rmdir /s /q "%programdata%\package cache\{6E886B33-257B-463D-8144-DF186C311472}v3.13.6.1085"
rmdir /s /q "%programdata%\package cache\{B7019F4B-BBD7-40DE-8FD3-3C561E51E0E1}v4.2.6.83"
rmdir /s /q "%programdata%\package cache\{2A75E14C-C008-4F28-8685-0F5940150B36}v4.2.6.83"
rmdir /s /q "%programdata%\package cache\{A2166A1D-63C1-41B5-AC13-2EAB4C80E9ED}v4.2.6.83"
rmdir /s /q "%programdata%\package cache\{FD89CD71-C072-49EC-98F6-CDB46FA31AA5}v4.2.6.83"
rmdir /s /q "%programdata%\package cache\{0FD19634-79FD-448F-8325-2864E7F65796}v3.13.7.12"
rmdir /s /q "%programdata%\package cache\{A865D8F1-E617-4301-8E31-A5939601D79B}v3.13.7.12"
rmdir /s /q "%programdata%\package cache\{92B46789-B70F-4BA1-9284-363AAE6AE5EC}v20.09.0.1881"

rem ----- Open-EID 20.10.0.1883 -----
rmdir /s /q "%programdata%\package cache\{4d3d0748-2abe-44f0-baf0-da24597f15ee}"
rmdir /s /q "%programdata%\package cache\{9777de6b-8231-4c92-b73a-8218c2fd8a7c}"
rmdir /s /q "%programdata%\package cache\{3CF3C9F9-020E-4CC9-9DD8-0E2E99DCFC83}v4.2.7.85"
rmdir /s /q "%programdata%\package cache\{5C3A4483-6E0B-406B-93A7-B6DA3E401F11}v4.2.7.85"
rmdir /s /q "%programdata%\package cache\{AA97B738-D5A1-46DA-9A29-A612CB412D51}v4.2.7.85"
rmdir /s /q "%programdata%\package cache\{7B3D89F3-89E7-44A6-BD5B-EA4CDC88F313}v4.2.7.85"
rmdir /s /q "%programdata%\package cache\{B2955ACB-9DFC-43CA-B7A5-90D9FFF6F572}v20.10.0.1883"

rem ----- Delete registry keys -----
regedit /s "%~dpn0.reg"

rem ----- Display final message for 4 seconds -----
echo.
choice /t 4 /d n /n /m "OK: Open-EID removal script has finished, this window will close soon..."
goto end

:error_message
echo.
echo ERROR: Please run this file as administrator!
echo.
pause

:end